package de.ugoe.cs.rwm.mocci.connector;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.cmf.occi.core.Link;
import org.eclipse.cmf.occi.core.MixinBase;
import org.modmacao.cm.ConfigurationManagementTool;
import org.modmacao.cm.ansible.AnsibleCMTool;
import org.modmacao.occi.platform.Component;
import org.modmacao.occi.platform.Status;


public class ComponentManager {

	private Component comp;
	
	public ComponentManager(Component comp) {
		this.comp = comp;
	}
	

	public void undeploy() {

				switch(comp.getOcciComponentState().getValue()) {

				case Status.ACTIVE_VALUE:
					
					comp.stop();
					comp.setOcciComponentState(Status.UNDEPLOYED);
					break;


				case Status.INACTIVE_VALUE:
					comp.setOcciComponentState(Status.UNDEPLOYED);
					break;


				case Status.DEPLOYED_VALUE:
					comp.setOcciComponentState(Status.UNDEPLOYED);
					break;


				case Status.ERROR_VALUE:
					comp.setOcciComponentState(Status.UNDEPLOYED);
					break;

				default:
					break;
		}
	}
	// End of user code
	// Start of user code Publisher_Kind_deploy_action
	/**
	 * Implement OCCI action:
     * - scheme: http://schemas.modmacao.org/occi/platform/component/action#
     * - term: deploy
     * - title: 
	 */
	public void deploy()
	{
		int status = -1;

		// Component State Machine.
		switch(comp.getOcciComponentState().getValue()) {

		case Status.UNDEPLOYED_VALUE:
			comp.setOcciComponentState(Status.DEPLOYED);
			break;
		
		default:
			break;
}
	}
	// End of user code
	// Start of user code Publisher_Kind_configure_action
	/**
	 * Implement OCCI action:
     * - scheme: http://schemas.modmacao.org/occi/platform/component/action#
     * - term: configure
     * - title: 
	 */
	public void configure()
	{
		int status = -1;

		// Component State Machine.
		switch(comp.getOcciComponentState().getValue()) {

		case Status.DEPLOYED_VALUE:
				comp.setOcciComponentState(Status.INACTIVE);
			break;
			
		default:
			break;
}
	}
	// End of user code
	// Start of user code Publisher_Kind_Start_action
	/**
	 * Implement OCCI action:
     * - scheme: http://schemas.modmacao.org/occi/platform/component/action#
     * - term: start
     * - title: Start the application.
	 */
	public void start()
	{
		int status = -1;

		// Component State Machine.
		switch(comp.getOcciComponentState().getValue()) {

		case Status.INACTIVE_VALUE:
				comp.setOcciComponentState(Status.ACTIVE);
			break;


		case Status.UNDEPLOYED_VALUE:
				comp.setOcciComponentState(Status.ERROR);
				break;

		default:
			break;
}
	}
	// End of user code
	// Start of user code Publisher_Kind_Stop_action
	/**
	 * Implement OCCI action:
     * - scheme: http://schemas.modmacao.org/occi/platform/component/action#
     * - term: stop
     * - title: Stop the application.
	 */
	public void stop()
	{
		int status = -1;
		// Component State Machine.
		switch(comp.getOcciComponentState().getValue()) {

		case Status.ACTIVE_VALUE:
						
			comp.setOcciComponentState(Status.INACTIVE);
		
			break;

		default:
			break;
}
	}
	// End of user code
	
	private boolean assertCompsStatusEquals(List<Component> components, Status status) {
		for (Component component: components) {
			if (component.getOcciComponentState().getValue() != status.getValue()) {
				return false;
			}
		}	
		return true;
}

}	